HELP              Michael Shiels' DOSIX Programmer's Manual                HELP



NAME
     help - user-friendly documentation reader


SYNOPSIS
     help [ -c<#>d<str>h<#>vw<#> ] [ topic-path ]


DESCRIPTION
     Help is a documentation reader based closely on the VMS(tm)
     help facility.  Documentation texts are arranged in a tree,
     and the users reads them with the built in interface or with
     another file viewer. Help allows documentation to be treated
     as an n-tree, the structure of the help tree is the structure
     of the directory tree in which the help files reside.

     The help program is invoked from the shell like

          help [ options ] topic sub-topic sub-sub-topic ...

     Topic may be any top-level help file name.  A topic-path is
     a path of topics and their subtopics, down into the tree.
     Topic and subtopic names may be abbreviated, but no wild-
     cards are recognized.

     The options are:

     c<#>   The number will be used as the number of columns for the
            Topic/Subtopic listings.

     d<str> Next argument is the help root directory.  Default is
            what ever $HELPDIR is set to or /usr/help.

     h<#>   The number will be used as the maximum number of help
            topics/subtopics which will ever occur at any level.
            This is usually set up in the HELP.RC file.

     v      This triggers vertical instead of horizontal printing
            of the help topics/subtopics.

     w<#>   The number will be used as the maximum number of help
            topics/subtopics which will be requested during an
            ambiguous helprequest.
            This is usually set up in the HELP.RC file.

     
     The help interactive mode asks the user what help he would
     like next.  The prompt looks like this:

     Topic?

     or like this:

      vi commands deletion Subtopic?

     Where "vi commands deletion" is the help tree path. This
     path is printed for each prompt, and as a header for each
     help text.

     The following commands are meaningful in to the "topic?"
     prompt:

     ?  Print current introduction and subtopic-list again.

     #  Print current introduction again.

     $  Print current subtopic-list again.

     !<CR>
        To shell to the current setting of $COMSPEC.

     !command
        To run the 'command' under $COMSPEC.

     Return <CR>
        Exit this level of help.  If at top level, goes back to
        calling program.

     <subtopic-name>
        Read the documentation for this subtopic, or all subto-
        pics for which this is a legal abbreviation.  Wildcards
        are not permitted, but a short abbreviation matches
        everything longer.

     ^Z Exit the help program.


HELP FILES

     Help files are the text and directories of the help documen-
     tation tree.  There are four kinds of help files: topic directory,
     introduction file, and subtopic file.

     The usual way of calling help is to just type

     % help

     in the shell.  This brings up help in interactive mode at the
     top level of topics.  The user can always abort with ctrl/Z.


GENERAL ENVIRONMENT VARIABLES
     SWITCHAR - is used to detect which character you wish to use for
                the command line option trigger.  Usually it is '/' but
                if you are a UNIXer you can set it to '-'.

     GETSOPTS - is used to locate the HELP.RC file which can be used
                to change some of the defaults for the command line
                switches.  Usually it is used to increase the number
                of help topics/subtopics which can be available at
                any one level.

     COMSPEC - this is used to locate the COMMAND shell.


ENVIRONMENT VARIABLES
     HELPOPTS - is used to override the HELP.RC file and set up personal
                command line preferences.

     HELPDIR - is the root of the help system.

     HELPDISPLAY1 - can be set to a program (such as more) which will be
                    used to display the introductory text file if there
                    is one.

     HELPDISPLAY2 - can be set to a program (such as more) which will be
                    used to display the help files.


EXAMPLE
     HELPDIR = J:/HELP
     Thie disk structure would look like this

     J:\HELP\INTRO.TXT              Introduction which will be display when
                                    the topics at this level are displayed
     J:\HELP\AUTOEXEC.HLP           Help Text
     J:\HELP\GNUPLOT.HLD            Subtopic Directory
     J:\HELP\GNUPLOT.HLD\PLOT.HLP   Subtopic Help Text
     J:\HELP\GNUPLOT.HLD\EXPR.HLD   SubSubtopic Directory
     ...


AUTHOR
     Michael A. Shiels ( mshiels@electrical.watstar.waterloo.EDU )
     604 Bridle Wood
     Burlington, Ontario
     CANADA, L7L 4C7


FILES
	 $GETSOPTS/HELP.RC
	 $HELPDIR/...
	 NANSI.SYS


NOTES
     This program will use the 'RAW' mode of the NANSI.SYS driver if it
     is loaded, but it can still be run with ANSI.SYS.

     All user prompting is read using 'cgets' so CED will work at the
     help prompts.


SEE ALSO
     more, pc-more, smore, list, nansi, ced.


DIAGNOSTICS
     Error messages are printed whenever a request is made to get
     documentation that does not exists, or is not accessible.


BUGS
     The file naming conventions are very strict.
